implementation module System._Memory

import code from library "ucrtbase"

from System._Pointer import :: Pointer

malloc :: !Int -> Pointer
malloc num = code {
	ccall malloc "I:p"
}

mallocSt :: !Int !*w -> (!Pointer, !*w)
mallocSt num w = code {
	ccall malloc "I:p:A"
}

free :: !Pointer -> Int
free ptr = code {
	ccall free "p:I"
}

freeSt :: !Pointer !*w -> *w
freeSt ptr world = code {
   ccall free "p:V:A"
}

memcpy :: !Pointer !Pointer !Int -> Pointer
memcpy s p n = code {
    ccall memcpy "ppI:p"
}

memcpySt :: !Pointer !Pointer !Int !*w -> *w
memcpySt s p n w = code {
    ccall memcpy "ppI:V:A"
}

memcpy_string_to_pointer :: !Pointer !{#Char} !Int -> Pointer
memcpy_string_to_pointer p s n = code {
    ccall memcpy "psp:p"
}

memcpy_string_to_pointer_st :: !Pointer !{#Char} !Int !*w -> *w
memcpy_string_to_pointer_st p s n w = code {
    ccall memcpy "psp:V:A"
}

memcpyPointerToString :: !{#Char} !Pointer !Int -> Pointer
memcpyPointerToString s p n = code {
    ccall memcpy "spI:p"
}

memcpyPointerToStringSt :: !{#Char} !Pointer !Int !*w -> *w
memcpyPointerToStringSt s p n w = code {
    ccall memcpy "spI:V:A"
}

memcmp :: !Pointer !Pointer !Int -> Int
memcmp ptr1 ptr2 num = code {
	ccall memcmp "ppI:I"
}

memcmpSt :: !Pointer !Pointer !Int !*w -> (!Int, !*w)
memcmpSt ptr1 ptr2 num w = code {
	ccall memcmp "ppI:I:A"
}
